require 'cgi'

def wrap_each(cmd, args = ARGV, line_max = 10000)
  IO.popen('-', 'r') do |pipe|
    if pipe
      child_pid = pipe.gets.to_i
      line = 0
      pipe.each do |l|
        yield l
        if line_max <= (line += 1)
          Process.kill(:INT, child_pid)
          yield nil
          break
        end
      end
    else
      puts $$
      exec(cmd, *args)
    end
  end
end

def w3m
  IO.popen("w3m -T text/html", 'w') do |pipe|
    yield pipe
  end
end

def w3m_wrap_each(cmd, args = ARGV, line_max = 10000)
  w3m do |w|
    wrap_each(cmd, args, line_max) do |line|
      if line
        w.puts(yield(CGI.escapeHTML(line))+'<br>')
      else
        w.puts('<hr>too many lines')
      end
    end
  end
end

def w3m_color(line)
  line.gsub!(/\x1b\[01;31m(\x1b?.*?)\x1b/, "<b>\\1</b>\x1b")
  line.gsub!(/\x1b\[(\d*;?\d*m|K)/, '')
  line
end

def w3m_grep(line)
  line.sub(/^([^:]+):(\d+)/,'<a href="\1#\2">\&</a>')
end

def argv_str(a=ARGV)
  a.map{|a|"'#{a.gsub("'",%q('\\\\''))}'"}*' '
end

if __FILE__ == $0
  #puts argv_str(["'"])
  #w3m_wrap_each('/tmp/slow.sh', [], 2) do |l|
  #  l
  #end
end

